"""
Undead Scourge - Originaly made by Kevin
Modified for full python advantages by
Steven Hartin - (freddukes)
"""

import es, random, gamethread, wcs, UndeadScourgeConfig
from UndeadScourgeConfig import *
from wcs import wcs
 
RaceName = 'Undead Scourge'
race = wcs.Race(RaceName)

race.registerSkill('Vampiric Aura',Vampiric_MaxRanks,Vampiric_LevelInterval,"Draw Health From the Damage you do to Others")
race.registerSkill("Unholy Aura",Unholy_MaxRanks,Unholy_LevelInterval,"Speed Boost")
race.registerSkill("Levitation",Levitation_MaxRanks,Levitation_LevelInterval,"Lower Gravity")
race.registerUltimate("Suicide Bomber",Suicide_RequiredLevel,Suicide_MaxRanks,Suicide_LevelInterval,"Hold down the ultimate key to build up the destruction power")
 
def player_spawn(event_var):
    userid = event_var['userid']
    UnholyAura_level = wcs.GetLevel(userid,RaceName,'Unholy Aura')
    if UnholyAura_level:
        plevel = UnholyAura_level / float(Unholy_Divider) + 1
        player = wcs.Command(userid)
        player.Speed(plevel)
        es.tell(userid,'#multi','#greenUnholy Aura #default- #lightgreenYou have gained a %.0f%% speed boost.'%((plevel-1)*100))
    Levitation_level = wcs.GetLevel(userid,RaceName,'Levitation')
    if Levitation_level:
        depth = 1 - Levitation_level / float(Levitation_Divider) 
        player = wcs.Command(userid)
        player.SetGravity(depth)
        es.tell(userid,'#multi','#greenLevitation #default- #lightgreenGravity now has a %.0f%% effect on you.'%(depth*100))
    Bomber_level = wcs.GetLevel(userid,RaceName, 'Suicide Bomber')
    if Bomber_level:
    	wcs.Command(userid).UpdateDict('BombDamage', 0)
 
#def player_hurt(ev):
def prep_hurt(ev):
    attacker = ev['attacker']
    userid = ev['userid']
    if ev['dmg_health']:
        dmg = int(ev['dmg_health'])
    else:
        dmg = 0
    vampiric = wcs.GetLevel(attacker, RaceName, 'Vampiric Aura')
    if vampiric and userid != attacker:
    	alpha = 60 + vampiric * 20
    	x,y,z = es.getplayerlocation(attacker)
    	xx,yy,zz = es.getplayerlocation(userid)
    	wcs.Effect().BeamCustom('#a','0','sprites/lgtning.vmt',x,y,z+20,xx,yy,zz+20,0.5,40,40,0,random.randint(128,255),random.randint(1,127),alpha)
        player = wcs.Command(attacker)
        amount = int(round(dmg*vampiric*(Vampiric_Percent/100.0)))
        player.Heal(amount)
        es.tell(attacker,'#multi','#greenVampiric Aura #default- #lightgreenYou have just drawn %s health from player %s'%(amount,es.getplayername(userid)))
    	
def player_ultimate_on(event_var):
	global Players
	userid = event_var['userid']
	Bomber_level = wcs.GetLevel(userid,RaceName,'Suicide Bomber')
	if Bomber_level:
		wcs.Command(userid).UpdateDict('BombDamage', 0)
		delay_name = 'delay_%s'%userid
		Increasedamage(userid, delay_name)
		
def Increasedamage(userid, Delayname):
	es.usermsg("create", "damage_increase", "HintText")
	es.usermsg("write","short","damage_increase",-1)
	a = wcs.Command(userid).ReturnDict('BombDamage')
	format = "Damage:\n-----------------------\n"
	if a < 20:
		es.emitsound('player',userid,'buttons/blip2.wav',0.5,0.5)
		wcs.Command(userid).ModDict('BombDamage',1) # + 1 to the BombDamage dict
		while a >= 0:
			a -= 1
			format += "|"
	else:
		format += "* MAX *"
	es.usermsg("write","string","damage_increase",format)
	es.usermsg("send","damage_increase",userid,0)
	es.usermsg("delete","damage_increase")
	gamethread.delayedname(0.5, Delayname, Increasedamage, (userid, Delayname) )
		
def player_death(event_var):
	userid = event_var['userid']
	Bomber_level = wcs.GetLevel(userid,RaceName,'Suicide Bomber')
	if Bomber_level:
		gamethread.cancelDelayed('delay_%s'%event_var['userid'])
		es.cexec(userid,'-ultimate')
		
def player_ultimate_off(event_var):
	userid = event_var['userid']
	player = wcs.Command(userid)
	Bomber_level = wcs.GetLevel(userid,RaceName,'Suicide Bomber')
	if Bomber_level:
		gamethread.cancelDelayed('delay_%s'%userid)
		damage = wcs.Command(userid).ReturnDict('BombDamage')
		p = wcs.Command(userid)
		p.AreaDamage('%s'%('#t' if event_var['es_userteam'] == '3' else '#c'),Bomber_level * Suicide_Distance * (damage/5), int(Bomber_level * Suicide_Damage * (damage/5)),userid)
		sound = 'weapons/%s'%random.choice(['explode3.wav','explode4.wav','explode5.wav','mortar/mortar_explode1.wav','mortar/mortar_explode2.wav','mortar/mortar_explode3.wav'])
		wcs.Effect().Smoke(userid)
		es.emitsound('player', userid, sound, 1.0, damage / 20)
		es.server.queuecmd('est_slay %s'%userid)
		p.UpdateDict('BombDamage',0)
